************************************************************************
        subroutine initparam
************************************************************************
*-----------------------------------------------------------------------
*       29.4.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2),csw,ccw
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),i,color
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname

C***	Check for lepton- and quark-number conservation
	if(quark(1)-quark(2)+quark(3)-quark(4)
     &	  +quark(5)-quark(6).ne.0) then
	  write(*,*) 'No lepton- and quark-number conservation !'
	  stop
	endif

C***	Check for weak-isospin conservation
	if(iso(1)-iso(2)+iso(3)-iso(4)+iso(5)-iso(6).ne.0) then
	  write(*,*) 'No weak-isospin conservation !'
	  stop
	endif

C***	Check for conservation of generation indices
	if(gen(1)-gen(2)+gen(3)-gen(4)+gen(5)-gen(6).ne.0) then
	  write(*,*) 'No weak-isospin conservation !'
	  stop
	endif

C*** 	Check for 2->4 reaction
	if (dir(1)+dir(2)+dir(3)+dir(4)+dir(5)+dir(6)+dir(7).ne.-3) then
	  write(*,*) 'Process is not 2 -> 4 !'
	  stop
	endif

C*** 	Gauge-boson masses, widths, and propagator flags, V = A,Z,W
	mv(1)  = 0d0
	mv(2)  = mz
	mv(3)  = mw
	mv2(1) = 0d0
	mv2(2) = mz**2
	mv2(3) = mw**2
	gv(1)  = 0d0
	gv(2)  = gz
	gv(3)  = gw

C***	Elmg. charges of fermions
	do 200 i=1,6
	  q(i) = (iso(i)-1d0)/2d0+quark(i)*2d0/3d0
200	continue

C*** 	Couplings of fermions to gauge bosons 
	if (qprop.eq.4) then
	  ccw = sqrt( dcmplx(mw**2,-mw*gw)/dcmplx(mz**2,-mz*gz) )
	  csw = sqrt( 1d0-ccw**2 )
	else
	  ccw = cw
	  csw = sw
	endif 
	do 300 i=1,6
	  cvf(-1,1,i) = -el*q(i)
	  cvf(+1,1,i) = -el*q(i)
	  cvf(-1,2,i) = -el*(q(i)*csw/ccw-iso(i)/2d0/csw/ccw)
	  cvf(+1,2,i) = -el* q(i)*csw/ccw
	  cvf(-1,3,i) =  el/sqrt(2d0)/csw
	  cvf(+1,3,i) = 0d0
300	continue

C***	Color and QCD factor factor
	color   = 3**(quark(1)+quark(3)+quark(5))
	qcdfac  = 0d0
	if (color.eq.9) qcdfac = alphas/alpha/q(3)/q(5)
	qcdfac2 = qcdfac**2
	
C***	Triple-gauge-boson couplings VW+W-
	cvw(1) =  el
	cvw(2) = -el*ccw/csw

	end

************************************************************************
        subroutine init_epem
************************************************************************
*	e+e- reactions: type = 1
*-----------------------------------------------------------------------
*	3 different classes of processes:
*		    CC processes: cc = 1, nc = 0
*		    NC processes: cc = 0, nc = 1
*	   mixed CC-NC processes: cc = 1, nc = 1
*-----------------------------------------------------------------------
*	Further classification:  (f,F =/= e-,n_e,
*				  f',F' = isospin partners of f,F, resp.)
*
*	              anti-f1 f2  -->  f3   anti-f4   f5   anti-f6
*	CC processes:
*	    sym = 0:    e+    e-  -->  f    anti-f'   F    anti-F' 
*	    sym = 1:    e+    e-  -->  n_e    e+      f    anti-f'
*	    sym = 2:    e+    e-  -->  f    anti-f'   e-   anti-n_e
*	NC processes:
*	    sym = 0:    e+    e-  -->  f    anti-f    F    anti-F 
*	    sym = 1:    e+    e-  -->  f    anti-f    f    anti-f 
*	    sym = 2:    e+    e-  -->  e-     e+      f    anti-f 
*	    sym = 3:    e+    e-  -->  e-     e+      e-     e+
*       mixed CC-NC processes: 
*	    sym = 0:    e+    e-  -->  f    anti-f    f'   anti-f'
*	    sym = 1:    e+    e-  -->  n_e  anti-n_e  f    anti-f 
*	    sym = 2:    e+    e-  -->  n_e  anti-n_e  n_e  anti-n_e
*	    sym = 3:    e+    e-  -->  n_e  anti-n_e  e-     e+
*-----------------------------------------------------------------------
*       7.6.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	integer type,nc,cc,sym,perm
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/processtype/type,nc,cc,sym,perm

c***	Check for e+e- initial state
	type = 0
	if ((quark(1).ne.0).or.(iso(1).ne.-1).or.(gen(1).ne.1).or.
     &	    (quark(2).ne.0).or.(iso(2).ne.-1).or.(gen(2).ne.1).or.
     &	    (dir(1).ne.1).or.(dir(2).ne.1)) then
	  write(*,*) 'Initial state is not e+e-.'
	  goto 100
	endif
	type = 1

c***	Check for correct (f3,f4) and (f5,f6) pairs
	if ((quark(3).ne.quark(4)).or.(gen(3).ne.gen(4)).or.
     &	    (quark(5).ne.quark(6)).or.(gen(5).ne.gen(6))) then
	  write(*,*) 'Quark/lepton numbers or generation indices'
	  write(*,*) 'are inconsistent in (f3,f4) and (f5,f6) pairs.'
	  goto 100
	endif

c***	Check for NC reaction
	nc = 0
	if ((iso(3).eq.iso(4)).and.(iso(5).eq.iso(6))) then
	  nc = 1
	endif

c***	Check for CC reaction
	cc = 0
	if ((iso(3).eq.+1).and.(iso(4).eq.-1).and. 
     &	    (iso(5).eq.-1).and.(iso(6).eq.+1)) then
	  cc = 1
	endif

c***	Check for NC or CC reaction
	if ((nc.eq.0).and.(cc.eq.0)) then
	  write(*,*) 'Final-state fermions are not in standard order.'
	  goto 100
	endif

c***	Check for mixed CC and NC reaction
	if (   ((nc.eq.1).and.(iso(3).eq.-iso(5)).and.
     &	        (quark(3).eq.quark(5)).and.(gen(3).eq.gen(5))) 
     &	   .or.((nc.eq.1).and.(quark(3).eq.0).and.(gen(3).eq.1).and.
     &	        (iso(3).eq.1)) ) then
	  cc = 1
	  if (iso(3).eq.-1) then
	    write(*,*) 'iso(3)=+1 required for mixed CC-NC reaction.'
	    goto 100
	  endif
	elseif ( (cc.eq.1).and.
     &	         (gen(3).eq.gen(6)).and.(quark(3).eq.quark(6)) ) then
	  write(*,*) 'Permutate final state to f anti-f F anti-F'
	  write(*,*) 'for mixed CC-NC reaction.'              
	  goto 100
	endif

c***	Determine crossing symmetries 
	sym = 0
	if ((cc.eq.1).and.(nc.eq.0)) then
	  if ((quark(4).eq.0).and.(gen(4).eq.1)) sym = 1
	  if ((quark(5).eq.0).and.(gen(5).eq.1)) sym = sym+2
	  if (sym.eq.3) then
	    write(*,*) 'Permutate final state to n_e anti-n_e e- e+.'
	    goto 100
	  endif
	elseif ((cc.eq.0).and.(nc.eq.1)) then
	  if ((quark(3).eq.quark(5)).and.(gen(3).eq.gen(5))) sym = 1
	  if ((quark(3).eq.0).and.(gen(3).eq.1)) sym = sym+2
	  if ((sym.eq.0).and.(quark(5).eq.0).and.(gen(5).eq.1)) then
	    write(*,*) 'Permutate final state to e- e+ f anti-f'
    	    write(*,*) '          or to nu_e anti-nu_e f anti-f.'
	    goto 100
	  endif
	elseif ((cc.eq.1).and.(nc.eq.1)) then
	  if ((quark(3).eq.0).and.(gen(3).eq.1)) sym = 1
	  if ((quark(5).eq.0).and.(gen(5).eq.1)) then
	    sym = 2
	    if (iso(5).eq.-1) sym = 3
	  endif
	endif

c***	Determine symmetry factor for final state
	perm = 1
	if ((quark(3).eq.quark(5)).and.(gen(3).eq.gen(5)).and.
     &	    (iso(3).eq.iso(5))) perm = perm*2
	if ((quark(4).eq.quark(6)).and.(gen(4).eq.gen(6)).and.
     &	    (iso(4).eq.iso(6))) perm = perm*2

	return
100	continue

	write(*,*) 'Reaction not implemented; check input !'
	stop

	end

************************************************************************
        subroutine procout
************************************************************************
*-----------------------------------------------------------------------
*       29.4.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	integer i,out,type,nc,cc,sym,perm,qsigepem4,qsigepem5,qqcdepem
	character*60 dname1,dname2,dname3,dname4
	character*16 rname,tname
	character*6 fname(6),dfname(6)
	character*3 ndir(-1:1)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/processtype/type,nc,cc,sym,perm
	common/contrib/qsigepem4,qsigepem5,qqcdepem
	common/out/out

2000	format(/,'Fermions:',9x,'species',6x,'dir',4x,'pol',4x,
     &	       'Q',5x,'I_w',/,'---------')
3000	format(a6,'f(',i1,'): ',4x,2a6,3x,a3,4x,i3,2x,f5.2,2x,f5.2)
4000	format(/,'Process type:',4x,a16,1x,a16,
     &	       /,'-------------')
5000	format(/,' permutation factor = 1 /',i2,/)
6000	format(/,'Contributions:',3x,a60,
     &	       /,'--------------',3x,a60,/,17x,a60,/,17x,a60)
7000	format(/,'Gauge-boson propagators:',3x,
     &		 'qprop =',i2,
     &	       /,'------------------------'
     &	       /,4x,'qprop = 0:   widths = 0',
     &	       /,4x,'        1:   constant width',
     &	       /,4x,'        2:   constant width * theta(p^2)',
     &	       /,4x,'        3:   running  width',
     &	       /,4x,'        4:   constant width and complex sw,cw')

	ndir(-1) = 'out'
	ndir(+1) = ' in'

	write(out,2000) 
	do 100 i=1,6
	  write(out,3000) dfname(i),i,dfname(i),fname(i),ndir(dir(i)),
     &		pol(i),(-1)**i*dir(i)*q(i),(-1)**i*dir(i)*iso(i)/2d0
100	continue

	write(out,5000) perm
	write(out,*)
	write(out,*)'                        |              '
	write(out,*)'                       /|\\ f3         '
	write(out,*)'                        |              '
	write(out,*)'                     XXXXXXX           '
	write(out,*)'            f1 --<--XXXXXXXXX--<-- f4  '
	write(out,*)'                    XXXXXXXXX          '
	write(out,*)'                    XXXXXXXXX          '
	write(out,*)'            f2 -->--XXXXXXXXX-->-- f5  '
	write(out,*)'                     XXXXXXX           '
	write(out,*)'                        |              '
	write(out,*)'                       /|\\ f6         '
	write(out,*)'                        |              '

	if (type.eq.1) rname='e+e- reaction of'

	if ((nc.eq.1).and.(cc.eq.1)) tname='mixed CC-NC type'
	if ((nc.eq.1).and.(cc.eq.0)) tname='NC type'
	if ((nc.eq.0).and.(cc.eq.1)) tname='CC type'

	if ((qqcdepem.eq.2)) then
	  dname1='only QCD background diagrams'
	  dname2='no purely electroweak diagrams'
	  dname3=' '
	  dname4=' '
	  goto 200
	endif

	if (qsigepem4.eq.0) then
	  dname1='4f:     all electroweak diagrams'
	elseif (qsigepem4.eq.1) then
	  dname1='4f:     only electroweak WW-signal diagrams'
	elseif (qsigepem4.eq.2) then
	  dname1='4f:     only electroweak ZZ-signal diagrams'
	elseif (qsigepem4.eq.3) then
	  dname1='4f:     only electroweak ZZ,ZA,AA-signal diagrams'
	elseif (qsigepem4.eq.4) then
	  dname1='4f:     only electroweak WW,ZZ,ZA,AA-signal diagrams'
	elseif (qsigepem4.eq.5) then
	  dname1='4f:     only diagrams of CC11 class'
	endif

	if (qsigepem5.eq.0) then
	  dname2='4f+A/g: all electroweak diagrams'
	elseif (qsigepem5.eq.1) then
	  dname2='4f+A/g: only electroweak WW-signal diagrams'
	elseif (qsigepem5.eq.2) then
	  dname2='4f+A/g: only electroweak ZZ-signal diagrams'
	elseif (qsigepem5.eq.3) then
	  dname2='4f+A/g: only electroweak ZZ,ZA,AA-signal diagrams'
	elseif (qsigepem5.eq.4) then
	  dname2='4f+A/g: only electroweak WW,ZZ,ZA,AA-signal diagrams'
	elseif (qsigepem5.eq.5) then
	  dname2='4f+A/g: only diagrams of CC11 class'
	endif

	if ((qqcdepem.eq.0).or.(qsigepem4.ne.0)) then
	  dname3='4f:     QCD background diagrams excluded'
	elseif (qqcdepem.eq.1) then
	  dname3='4f:     QCD background diagrams included'
	endif

	if ((qqcdepem.eq.0).or.(qsigepem5.ne.0)) then
	  dname4='4f+A/g: QCD background diagrams excluded'
	elseif (qqcdepem.eq.1) then
	  dname4='4f+A/g: QCD background diagrams included'
	endif

200	continue

	write(out,4000) rname,tname
	write(out,6000) dname1,dname2,dname3,dname4
	write(out,7000) qprop

	end

************************************************************************
        function M2_epem_4f(p)
************************************************************************
*       Calculation of |M|^2 for process 
*		e+ e-  --> f3 anti-f4 f5 anti-f6
*	Selection of diagrams
*	   qsigepem4 =  0: all diagrams
*	      "       1-4: only signal diagrams (e+e- -> V1V2 -> 4f )
*	      "         1:   V1V2 = WW
*	      "         2:   V1V2 = ZZ
*	      "         3:   V1V2 = ZZ,gammaZ,Zgamma,gammagamma
*	      "         4:   V1V2 = WW,ZZ,gammaZ,Zgamma,gammagamma
*	      "         5: only diagrams for CC11 class
*	   qqcdepem  =  0: gluon-exchange diagrams excluded
*	      "         1: gluon-exchange diagrams included
*	      "         2: only gluon-exchange diagrams 
*			     (no purely electroweak ones!) 
*-----------------------------------------------------------------------
*       7.6.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M1(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 M2(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 Mg1(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 Mg2(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 mm1,mm2,cm2,mmg1,mmg2,cmg2
	complex*16 cvf(-1:1,3,6),cvw(2)
	real*8 q(6),mv(3),mv2(3),gv(3),p(7,0:3)
	integer i,i1,i2,i3,i4,i5,i6,color,qsigepem4,qsigepem5,qqcdepem
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7)
	integer type,nc,cc,sym,perm
	integer g3p,g3m,g4p,g4m,g5p,g5m,g6p,g6m
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/processtype/type,nc,cc,sym,perm
	common/contrib/qsigepem4,qsigepem5,qqcdepem
        common/pol/pm,pp
        common/M2flip/M2flip(6)
	
        call setM6null(M1)
        call setM6null(M2)
        call setM6null(Mg1)
        call setM6null(Mg2)

c***  CC reaction
c================
	if ((nc.eq.0).and.(cc.eq.1)) then
	  if ((qqcdepem.ne.2).and.
     &	      (qsigepem4.ne.2).and.(qsigepem4.ne.3)) then
            call M_CC(M1,+1,1,2,3,4,5,6)
	    if ((sym.eq.1).and.(qsigepem4.eq.0)) then
              call M_CC(M1,-1,1,4,3,2,5,6)
	    elseif ((sym.eq.2).and.(qsigepem4.eq.0)) then
              call M_CC(M1,-1,5,2,3,4,1,6)
	    endif
	  endif
c*** No QCD background diagrams for genuine CC reactions !

c***  NC reaction 
c================
	elseif ((nc.eq.1).and.(cc.eq.0)) then
	  if (qsigepem4.eq.5) then
            M2_epem_4f = 0d0
	    return
	  endif
	  if ((qqcdepem.ne.2).and.(qsigepem4.ne.1)) then
            call M_NC(M1,+1,1,2,3,4,5,6)
	    if (sym.eq.1) then
	      if (color.eq.9) then
                call M_NC(M2,-1,1,2,5,4,3,6)
	      else
                call M_NC(M1,-1,1,2,5,4,3,6)
	      endif
	    elseif ((sym.eq.2).and.(qsigepem4.eq.0)) then
              call M_NC(M1,-1,3,2,1,4,5,6)
	    elseif (sym.eq.3) then
              call M_NC(M1,-1,1,2,5,4,3,6)
	      if (qsigepem4.eq.0) then
                call M_NC(M1,-1,3,2,1,4,5,6)
                call M_NC(M1,+1,3,2,5,4,1,6)
                call M_NC(M1,-1,5,2,3,4,1,6)
                call M_NC(M1,+1,5,2,1,4,3,6)
	      endif
	    endif
	  endif
c*** QCD background diagrams 
	  if ((qqcdepem.ge.1).and.(qsigepem4.eq.0).and.(color.eq.9)) then
              call Mg_NC(Mg1,+1,1,2,3,4,5,6)
	    if (sym.eq.1) then
              call Mg_NC(Mg2,-1,1,2,5,4,3,6)
	    endif
	  endif

c***  mixed CC-NC reaction
c=========================
	elseif ((nc.eq.1).and.(cc.eq.1)) then
	  if (qqcdepem.ne.2) then
	    if ((qsigepem4.ne.1).and.(qsigepem4.ne.5)) 
     &	      call M_NC(M1,+1,1,2,3,4,5,6)
	    if (sym.eq.0) then
	      if (color.eq.9) then
                if ((qsigepem4.ne.2).and.(qsigepem4.ne.3))
     &		  call M_CC(M2,-1,1,2,3,6,5,4)
	      else
                if ((qsigepem4.ne.2).and.(qsigepem4.ne.3))
     &            call M_CC(M1,-1,1,2,3,6,5,4)
	      endif
	    elseif ((sym.eq.1).and.(qsigepem4.eq.0)) then
              call M_CC(M1,-1,5,6,3,2,1,4)
	    elseif (sym.eq.2) then
	      if ((qsigepem4.ne.1).and.(qsigepem4.ne.5)) 
     &		call M_NC(M1,-1,1,2,5,4,3,6)
	      if (qsigepem4.eq.0) then
                call M_CC(M1,-1,3,4,1,6,5,2)
                call M_CC(M1,+1,3,6,1,4,5,2)
                call M_CC(M1,+1,5,4,1,6,3,2)
                call M_CC(M1,-1,5,6,1,4,3,2)
	      endif
	    elseif (sym.eq.3) then
              if ((qsigepem4.ne.2).and.(qsigepem4.ne.3))
     &          call M_CC(M1,-1,1,2,3,6,5,4)
	      if (qsigepem4.eq.0) then
                call M_NC(M1,-1,5,2,3,4,1,6)
                call M_CC(M1,+1,1,6,3,2,5,4)
                call M_CC(M1,+1,5,2,3,6,1,4)
                call M_CC(M1,-1,5,6,3,2,1,4)
	      endif
	    endif
	  endif
c*** QCD background diagrams 
	  if ((qqcdepem.ge.1).and.(qsigepem4.eq.0).and.(color.eq.9)) then
            call Mg_NC(Mg1,+1,1,2,3,4,5,6)
	  endif
	endif
	
	M2_epem_4f = 0d0
	do 200 i=1,6
          M2flip(i)  = 0d0
200	continue

	do 100 i1=-1,1,2
	  f1p = 1d0+pp*i1
	  f1m = 1d0-pp*i1
	do 100 i2=-1,1,2
	  f2p = 1d0+pm*i2
	  f2m = 1d0-pm*i2
	do 100 i3=-1,1,2
	  g3p = (2+pol(3)*i3)/2
	  g3m = (2-pol(3)*i3)/2
	do 100 i4=-1,1,2
	  g4p = (2+pol(4)*i4)/2
	  g4m = (2-pol(4)*i4)/2
	do 100 i5=-1,1,2
	  g5p = (2+pol(5)*i5)/2
	  g5m = (2-pol(5)*i5)/2
	do 100 i6=-1,1,2
	  g6p = (2+pol(6)*i6)/2
	  g6m = (2-pol(6)*i6)/2
	  mm1  =         M1(i1,i2,i3,i4,i5,i6)
	  mm2  =         M2(i1,i2,i3,i4,i5,i6)
	  cm2  = dconjg( M2(i1,i2,i3,i4,i5,i6))
	  mmg1 =        Mg1(i1,i2,i3,i4,i5,i6)
	  mmg2 =        Mg2(i1,i2,i3,i4,i5,i6)
	  cmg2 = dconjg(Mg2(i1,i2,i3,i4,i5,i6))
          dM2  = ( (abs( mm1)**2+abs( mm2)**2+2d0/3d0*dreal( mm1* cm2))
     &		    *color
     &	          + (abs(mmg1)**2+abs(mmg2)**2-2d0/3d0*dreal(mmg1*cmg2))
     &	            *2d0*qcdfac2 
     &	          + (dreal(mm1*cmg2)+dreal(cm2*mmg1))*8d0*qcdfac 
     &		 )/perm/4d0

	  M2_epem_4f = M2_epem_4f + dM2*f1p*f2p*g3p*g4p*g5p*g6p
	  M2flip(1)  = M2flip(1)  + dM2*f1m*f2p*g3p*g4p*g5p*g6p
	  M2flip(2)  = M2flip(2)  + dM2*f1p*f2m*g3p*g4p*g5p*g6p
	  M2flip(3)  = M2flip(3)  + dM2*f1p*f2p*g3m*g4p*g5p*g6p
	  M2flip(4)  = M2flip(4)  + dM2*f1p*f2p*g3p*g4m*g5p*g6p
	  M2flip(5)  = M2flip(5)  + dM2*f1p*f2p*g3p*g4p*g5m*g6p
	  M2flip(6)  = M2flip(6)  + dM2*f1p*f2p*g3p*g4p*g5p*g6m
100	continue

	end

************************************************************************
        subroutine M_CC(M,sgn,if1,if2,if3,if4,if5,if6)
************************************************************************
*-----------------------------------------------------------------------
*       7.6.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	integer    sgn,if1,if2,if3,if4,if5,if6
	integer    qsigepem4,qsigepem5,qqcdepem

	common/contrib/qsigepem4,qsigepem5,qqcdepem

c*** signal diagrams
	if ((qsigepem4.ne.2).and.(qsigepem4.ne.3)) then
          call addMvvv(M,sgn,if1,if2,if3,if4,if5,if6,1)
          call addMvvv(M,sgn,if1,if2,if3,if4,if5,if6,2)
          call  addMvv(M,sgn,if1,if2,if3,if4,if5,if6,3,3)
	endif
c*** background diagrams
	if ((qsigepem4.eq.0).or.(qsigepem4.eq.5)) then
          call addMvv(M,sgn,if3,if4,if1,if2,if5,if6,1,3)
          call addMvv(M,sgn,if3,if4,if1,if2,if5,if6,2,3)
          call addMvv(M,sgn,if5,if6,if1,if2,if3,if4,1,3)
          call addMvv(M,sgn,if5,if6,if1,if2,if3,if4,2,3)
          call addMvv(M,sgn,if3,if4,if5,if6,if1,if2,3,1)
          call addMvv(M,sgn,if3,if4,if5,if6,if1,if2,3,2)
          call addMvv(M,sgn,if5,if6,if3,if4,if1,if2,3,1)
          call addMvv(M,sgn,if5,if6,if3,if4,if1,if2,3,2)
	endif

	end

************************************************************************
        subroutine M_NC(M,sgn,if1,if2,if3,if4,if5,if6)
************************************************************************
*-----------------------------------------------------------------------
*       7.6.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	integer    sgn,if1,if2,if3,if4,if5,if6
	integer    qsigepem4,qsigepem5,qqcdepem

	common/contrib/qsigepem4,qsigepem5,qqcdepem

c*** signal diagrams
	if (qsigepem4.ne.1) then
          call addMvv(M,sgn,if1,if2,if3,if4,if5,if6,2,2)
          call addMvv(M,sgn,if1,if2,if5,if6,if3,if4,2,2)
	endif
	if ((qsigepem4.eq.0).or.(qsigepem4.ge.3)) then
          call addMvv(M,sgn,if1,if2,if3,if4,if5,if6,2,1)
          call addMvv(M,sgn,if1,if2,if5,if6,if3,if4,2,1)
          call addMvv(M,sgn,if1,if2,if3,if4,if5,if6,1,2)
          call addMvv(M,sgn,if1,if2,if5,if6,if3,if4,1,2)
          call addMvv(M,sgn,if1,if2,if3,if4,if5,if6,1,1)
          call addMvv(M,sgn,if1,if2,if5,if6,if3,if4,1,1)
	endif
c*** background diagrams
	if (qsigepem4.eq.0) then
          call addMvv(M,sgn,if3,if4,if1,if2,if5,if6,1,1)
          call addMvv(M,sgn,if3,if4,if1,if2,if5,if6,1,2)
          call addMvv(M,sgn,if3,if4,if1,if2,if5,if6,2,1)
          call addMvv(M,sgn,if3,if4,if1,if2,if5,if6,2,2)
          call addMvv(M,sgn,if5,if6,if1,if2,if3,if4,1,1)
          call addMvv(M,sgn,if5,if6,if1,if2,if3,if4,1,2)
          call addMvv(M,sgn,if5,if6,if1,if2,if3,if4,2,1)
          call addMvv(M,sgn,if5,if6,if1,if2,if3,if4,2,2)
          call addMvv(M,sgn,if3,if4,if5,if6,if1,if2,1,1)
          call addMvv(M,sgn,if3,if4,if5,if6,if1,if2,1,2)
          call addMvv(M,sgn,if3,if4,if5,if6,if1,if2,2,1)
          call addMvv(M,sgn,if3,if4,if5,if6,if1,if2,2,2)
          call addMvv(M,sgn,if5,if6,if3,if4,if1,if2,1,1)
          call addMvv(M,sgn,if5,if6,if3,if4,if1,if2,1,2)
          call addMvv(M,sgn,if5,if6,if3,if4,if1,if2,2,1)
          call addMvv(M,sgn,if5,if6,if3,if4,if1,if2,2,2)
	endif

	end
	
************************************************************************
        subroutine Mg_NC(Mg,sgn,if1,if2,if3,if4,if5,if6)
************************************************************************
*	QCD background diagrams for e+e- --> 4 quarks
*	Note: 1-photon exchange is converted into 1-gluon exchange 
*	      by adjusting the prefactor of the diagrams
*-----------------------------------------------------------------------
*       16.10.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 Mg(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	integer    sgn,if1,if2,if3,if4,if5,if6

        call addMvv(Mg,sgn,if3,if4,if1,if2,if5,if6,1,1)
        call addMvv(Mg,sgn,if3,if4,if1,if2,if5,if6,2,1)
        call addMvv(Mg,sgn,if5,if6,if1,if2,if3,if4,1,1)
        call addMvv(Mg,sgn,if5,if6,if1,if2,if3,if4,2,1)
        call addMvv(Mg,sgn,if3,if4,if5,if6,if1,if2,1,1)
        call addMvv(Mg,sgn,if3,if4,if5,if6,if1,if2,1,2)
        call addMvv(Mg,sgn,if5,if6,if3,if4,if1,if2,1,1)
        call addMvv(Mg,sgn,if5,if6,if3,if4,if1,if2,1,2)

	end
	
************************************************************************
        function M2_epem_4fA(p)
************************************************************************
*       Calculation of |M|^2 for process 
*		e+ e-  --> f3 anti-f4 f5 anti-f6 + photon
*	Selection of diagrams
*	   qsigepem5 =   0: all diagrams
*	      "       1-4: only signal diagrams (e+e- -> V1V2 -> 4f+gamma )
*	      "         1:   V1V2 = WW
*	      "         2:   V1V2 = ZZ
*	      "         3:   V1V2 = ZZ,gammaZ,Zgamma,gammagamma
*	      "         4:   V1V2 = WW,ZZ,gammaZ,Zgamma,gammagamma
*	      "         5: only diagrams for CC11 class
*	   qqcdepem =   0: gluon-exchange diagrams excluded
*	      "         1: gluon-exchange diagrams included
*	      "         2: only gluon-exchange diagrams 
*			     (no purely electroweak ones!) 
*-----------------------------------------------------------------------
*       7.6.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16  M1(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16  M2(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 Mg1(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 Mg2(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 mm1,mm2,cm2,mmg1,mmg2,cmg2
	complex*16 cvf(-1:1,3,6),cvw(2)
	real*8 q(6),mv(3),mv2(3),gv(3),p(7,0:3)
	integer i1,i2,i3,i4,i5,i6,i7,color,qsigepem4,qsigepem5,qqcdepem
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7)
	integer type,nc,cc,sym,perm
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/processtype/type,nc,cc,sym,perm
	common/contrib/qsigepem4,qsigepem5,qqcdepem
        common/pol/pm,pp
	
        call setM7null(M1)
        call setM7null(M2)
        call setM7null(Mg1)
        call setM7null(Mg2)

c***  CC reaction
c================
	if ((nc.eq.0).and.(cc.eq.1)) then
          if ((qqcdepem.ne.2).and.
     &        (qsigepem5.ne.2).and.(qsigepem5.ne.3)) then
            call M_CCA(M1,+1,1,2,3,4,5,6)
	    if ((sym.eq.1).and.(qsigepem5.eq.0)) then
              call M_CCA(M1,-1,1,4,3,2,5,6)
	    elseif ((sym.eq.2).and.(qsigepem5.eq.0)) then
              call M_CCA(M1,-1,5,2,3,4,1,6)
	    endif
	  endif
c*** No QCD background diagrams for genuine CC reactions !

c***  NC reaction 
c================
	elseif ((nc.eq.1).and.(cc.eq.0)) then
	  if (qsigepem5.eq.5) then
            M2_epem_4fA = 0d0
	    return
	  endif
          if ((qqcdepem.ne.2).and.(qsigepem5.ne.1)) then
              call M_NCA(M1,+1,1,2,3,4,5,6)
	    if (sym.eq.1) then
	      if (color.eq.9) then
                call M_NCA(M2,-1,1,2,5,4,3,6)
	      else
                call M_NCA(M1,-1,1,2,5,4,3,6)
	      endif
	    elseif ((sym.eq.2).and.(qsigepem5.eq.0)) then
              call M_NCA(M1,-1,3,2,1,4,5,6)
	    elseif (sym.eq.3) then
              call M_NCA(M1,-1,1,2,5,4,3,6)
	      if (qsigepem5.eq.0) then
                call M_NCA(M1,-1,3,2,1,4,5,6)
                call M_NCA(M1,+1,3,2,5,4,1,6)
                call M_NCA(M1,-1,5,2,3,4,1,6)
                call M_NCA(M1,+1,5,2,1,4,3,6)
	      endif
	    endif
	  endif
c*** QCD background diagrams 
	  if ((qqcdepem.ge.1).and.(qsigepem5.eq.0).and.(color.eq.9)) then
              call Mg_NCA(Mg1,+1,1,2,3,4,5,6)
	    if (sym.eq.1) then
              call Mg_NCA(Mg2,-1,1,2,5,4,3,6)
	    endif
	  endif

c***  mixed CC-NC reaction
c=========================
	elseif ((nc.eq.1).and.(cc.eq.1)) then
	  if (qqcdepem.ne.2) then
	    if ((qsigepem5.ne.1).and.(qsigepem5.ne.5)) 
     &	      call M_NCA(M1,+1,1,2,3,4,5,6)
	    if (sym.eq.0) then
	      if (color.eq.9) then
                if ((qsigepem5.ne.2).and.(qsigepem5.ne.3))
     &            call M_CCA(M2,-1,1,2,3,6,5,4)
	      else
                if ((qsigepem5.ne.2).and.(qsigepem5.ne.3))
     &            call M_CCA(M1,-1,1,2,3,6,5,4)
	      endif
	    elseif ((sym.eq.1).and.(qsigepem5.eq.0)) then
              call M_CCA(M1,-1,5,6,3,2,1,4)
	    elseif (sym.eq.2) then
	      if ((qsigepem5.ne.1).and.(qsigepem5.ne.5)) 
     &		call M_NCA(M1,-1,1,2,5,4,3,6)
	      if (qsigepem5.eq.0) then
                call M_CCA(M1,-1,3,4,1,6,5,2)
                call M_CCA(M1,+1,3,6,1,4,5,2)
                call M_CCA(M1,+1,5,4,1,6,3,2)
                call M_CCA(M1,-1,5,6,1,4,3,2)
	      endif
	    elseif (sym.eq.3) then
              if ((qsigepem5.ne.2).and.(qsigepem5.ne.3))
     &          call M_CCA(M1,-1,1,2,3,6,5,4)
	      if (qsigepem5.eq.0) then
                call M_NCA(M1,-1,5,2,3,4,1,6)
                call M_CCA(M1,+1,1,6,3,2,5,4)
                call M_CCA(M1,+1,5,2,3,6,1,4)
                call M_CCA(M1,-1,5,6,3,2,1,4)
	      endif
	    endif
	  endif
c*** QCD background diagrams 
	  if ((qqcdepem.ge.1).and.(qsigepem5.eq.0).and.(color.eq.9)) then
            call Mg_NCA(Mg1,+1,1,2,3,4,5,6)
	  endif
	endif

	M2_epem_4fA = 0d0
	do 100 i1=-1,1,2
	do 100 i2=-1,1,2
	do 100 i3=-1,1,2
	do 100 i4=-1,1,2
	do 100 i5=-1,1,2
	do 100 i6=-1,1,2
	do 100 i7=-1,1,2
	  mm1  =         M1(i1,i2,i3,i4,i5,i6,i7)
	  mm2  =         M2(i1,i2,i3,i4,i5,i6,i7)
	  cm2  = dconjg( M2(i1,i2,i3,i4,i5,i6,i7))
	  mmg1 =        Mg1(i1,i2,i3,i4,i5,i6,i7)
	  mmg2 =        Mg2(i1,i2,i3,i4,i5,i6,i7)
	  cmg2 = dconjg(Mg2(i1,i2,i3,i4,i5,i6,i7))
	  M2_epem_4fA = M2_epem_4fA + 
     &	    (   (abs( mm1)**2+abs( mm2)**2+2d0/3d0*dreal( mm1* cm2))
     &		*color
     &	      + (abs(mmg1)**2+abs(mmg2)**2-2d0/3d0*dreal(mmg1*cmg2))
     &	        *2d0*qcdfac2 
     &	      + (dreal(mm1*cmg2)+dreal(cm2*mmg1))*8d0*qcdfac
     &	    )/perm 
     &	    *(1d0+pp*i1)*(1d0+pm*i2)/4d0
     &	    *int((2+pol(3)*i3)/2)*int((2+pol(4)*i4)/2)
     &	    *int((2+pol(5)*i5)/2)*int((2+pol(6)*i6)/2)
     &	    *int((2+pol(7)*i7)/2)
100	continue

c*** set real-photon coupling to alpha0
	M2_epem_4fA = M2_epem_4fA*alpha0/alpha

	end

************************************************************************
        function M2_epem_4fG(p)
************************************************************************
*       Calculation of |M|^2 for process 
*		e+ e-  --> f3 anti-f4 f5 anti-f6 + gluon
*	Selection of diagrams
*	   qsigepem5 =   0: *** NOT YET IMPLEMENTED ***
*	      "       1-4: only signal diagrams (e+e- -> V1V2 -> 4f+gluon )
*	      "         1:   V1V2 = WW
*	      "         2:   *** NOT YET IMPLEMENTED ***
*	      "         3:   *** NOT YET IMPLEMENTED ***
*	      "         4:   *** NOT YET IMPLEMENTED ***
*	      "         5: only diagrams for CC11 class
*-----------------------------------------------------------------------
*       16.8.99 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16  M1(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16  M2(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 mm1,mm2
	complex*16 cvf(-1:1,3,6),cvw(2)
	real*8 q(6),mv(3),mv2(3),gv(3),p(7,0:3)
	integer i1,i2,i3,i4,i5,i6,i7,color,qsigepem4,qsigepem5,qqcdepem
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7)
	integer type,nc,cc,sym,perm
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/processtype/type,nc,cc,sym,perm
	common/contrib/qsigepem4,qsigepem5,qqcdepem
        common/pol/pm,pp
	
        call setM7null(M1)
        call setM7null(M2)

c***  CC reaction
c================
	if ((nc.eq.0).and.(cc.eq.1)) then
          if (quark(3).eq.1) call M_CCG34(M1,+1,1,2,3,4,5,6)
          if (quark(5).eq.1) call M_CCG56(M2,+1,1,2,3,4,5,6)

c***  NC reaction 
c================
	elseif ((nc.eq.1).and.(cc.eq.0)) then
          M2_epem_4fG = 0d0
	  return

c***  mixed CC-NC reaction
c=========================
	elseif ((nc.eq.1).and.(cc.eq.1)) then
          if (quark(3).eq.1) call M_CCG34(M1,-1,1,2,3,6,5,4)
          if (quark(5).eq.1) call M_CCG56(M2,-1,1,2,3,6,5,4)
	endif

	M2_epem_4fG = 0d0
	do 100 i1=-1,1,2
	do 100 i2=-1,1,2
	do 100 i3=-1,1,2
	do 100 i4=-1,1,2
	do 100 i5=-1,1,2
	do 100 i6=-1,1,2
	do 100 i7=-1,1,2
	  mm1 = M1(i1,i2,i3,i4,i5,i6,i7)
	  mm2 = M2(i1,i2,i3,i4,i5,i6,i7)
	  M2_epem_4fG = M2_epem_4fG + 
     &	    (abs(mm1)**2+abs(mm2)**2)
     &	    *16d0/3d0*pi*alphas
     &	    *color/perm 
     &	    *(1d0+pp*i1)*(1d0+pm*i2)/4d0
     &	    *int((2+pol(3)*i3)/2)*int((2+pol(4)*i4)/2)
     &	    *int((2+pol(5)*i5)/2)*int((2+pol(6)*i6)/2)
     &	    *int((2+pol(7)*i7)/2)
100	continue

	end

************************************************************************
        subroutine M_CCA(M,sgn,if1,if2,if3,if4,if5,if6)
************************************************************************
*-----------------------------------------------------------------------
*       7.6.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	integer    sgn,if1,if2,if3,if4,if5,if6
	integer    qsigepem4,qsigepem5,qqcdepem

	common/contrib/qsigepem4,qsigepem5,qqcdepem
	
c*** signal diagrams
	if ((qsigepem5.ne.2).and.(qsigepem5.ne.3)) then
          call addMAvvv(M,sgn,if1,if2,if3,if4,if5,if6,1)
          call addMAvvv(M,sgn,if1,if2,if3,if4,if5,if6,2)
          call  addMAvv(M,sgn,if1,if2,if3,if4,if5,if6,3,3)
	endif
c*** background diagrams
	if ((qsigepem5.eq.0).or.(qsigepem5.eq.5)) then
          call addMAvv(M,sgn,if3,if4,if1,if2,if5,if6,1,3)
          call addMAvv(M,sgn,if3,if4,if1,if2,if5,if6,2,3)
          call addMAvv(M,sgn,if3,if4,if5,if6,if1,if2,3,1)
          call addMAvv(M,sgn,if3,if4,if5,if6,if1,if2,3,2)
          call addMAvv(M,sgn,if5,if6,if1,if2,if3,if4,1,3)
          call addMAvv(M,sgn,if5,if6,if1,if2,if3,if4,2,3)
          call addMAvv(M,sgn,if5,if6,if3,if4,if1,if2,3,1)
          call addMAvv(M,sgn,if5,if6,if3,if4,if1,if2,3,2)
	endif

	end

************************************************************************
        subroutine M_CCG34(M,sgn,if1,if2,if3,if4,if5,if6)
************************************************************************
*-----------------------------------------------------------------------
*       16.8.99 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	integer    sgn,if1,if2,if3,if4,if5,if6
	integer    qsigepem4,qsigepem5,qqcdepem

	common/contrib/qsigepem4,qsigepem5,qqcdepem
	
c*** signal diagrams
	if ((qsigepem5.ne.2).and.(qsigepem5.ne.3)) then
          call addMG56vvv(M,sgn,if1,if2,if5,if6,if3,if4,1)
          call addMG56vvv(M,sgn,if1,if2,if5,if6,if3,if4,2)
          call  addMG34vv(M,sgn,if1,if2,if3,if4,if5,if6,3,3)
	endif
c*** background diagrams
	if ((qsigepem5.eq.0).or.(qsigepem5.eq.5)) then
          call addMG12vv(M,sgn,if3,if4,if1,if2,if5,if6,1,3)
          call addMG12vv(M,sgn,if3,if4,if1,if2,if5,if6,2,3)
          call addMG12vv(M,sgn,if3,if4,if5,if6,if1,if2,3,1)
          call addMG12vv(M,sgn,if3,if4,if5,if6,if1,if2,3,2)
          call addMG56vv(M,sgn,if5,if6,if1,if2,if3,if4,1,3)
          call addMG56vv(M,sgn,if5,if6,if1,if2,if3,if4,2,3)
          call addMG34vv(M,sgn,if5,if6,if3,if4,if1,if2,3,1)
          call addMG34vv(M,sgn,if5,if6,if3,if4,if1,if2,3,2)
	endif

	end

************************************************************************
        subroutine M_CCG56(M,sgn,if1,if2,if3,if4,if5,if6)
************************************************************************
*-----------------------------------------------------------------------
*       16.8.99 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	integer    sgn,if1,if2,if3,if4,if5,if6
	integer    qsigepem4,qsigepem5,qqcdepem

	common/contrib/qsigepem4,qsigepem5,qqcdepem
	
c*** signal diagrams
	if ((qsigepem5.ne.2).and.(qsigepem5.ne.3)) then
          call addMG56vvv(M,sgn,if1,if2,if3,if4,if5,if6,1)
          call addMG56vvv(M,sgn,if1,if2,if3,if4,if5,if6,2)
          call  addMG56vv(M,sgn,if1,if2,if3,if4,if5,if6,3,3)
	endif
c*** background diagrams
	if ((qsigepem5.eq.0).or.(qsigepem5.eq.5)) then
          call addMG56vv(M,sgn,if3,if4,if1,if2,if5,if6,1,3)
          call addMG56vv(M,sgn,if3,if4,if1,if2,if5,if6,2,3)
          call addMG34vv(M,sgn,if3,if4,if5,if6,if1,if2,3,1)
          call addMG34vv(M,sgn,if3,if4,if5,if6,if1,if2,3,2)
          call addMG12vv(M,sgn,if5,if6,if1,if2,if3,if4,1,3)
          call addMG12vv(M,sgn,if5,if6,if1,if2,if3,if4,2,3)
          call addMG12vv(M,sgn,if5,if6,if3,if4,if1,if2,3,1)
          call addMG12vv(M,sgn,if5,if6,if3,if4,if1,if2,3,2)
	endif

	end

************************************************************************
        subroutine M_NCA(M,sgn,if1,if2,if3,if4,if5,if6)
************************************************************************
*-----------------------------------------------------------------------
*       7.6.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	integer    sgn,if1,if2,if3,if4,if5,if6
	integer    qsigepem4,qsigepem5,qqcdepem

	common/contrib/qsigepem4,qsigepem5,qqcdepem

c*** signal diagrams
	if (qsigepem5.ne.1) then
          call addMAvv(M,sgn,if1,if2,if3,if4,if5,if6,2,2)
          call addMAvv(M,sgn,if1,if2,if5,if6,if3,if4,2,2)
        endif
        if ((qsigepem5.eq.0).or.(qsigepem5.ge.3)) then
          call addMAvv(M,sgn,if1,if2,if3,if4,if5,if6,2,1)
          call addMAvv(M,sgn,if1,if2,if5,if6,if3,if4,2,1)
          call addMAvv(M,sgn,if1,if2,if3,if4,if5,if6,1,2)
          call addMAvv(M,sgn,if1,if2,if5,if6,if3,if4,1,2)
          call addMAvv(M,sgn,if1,if2,if3,if4,if5,if6,1,1)
          call addMAvv(M,sgn,if1,if2,if5,if6,if3,if4,1,1)
        endif
c*** background diagrams
	if (qsigepem5.eq.0) then
          call addMAvv(M,sgn,if3,if4,if1,if2,if5,if6,1,1)
          call addMAvv(M,sgn,if3,if4,if1,if2,if5,if6,1,2)
          call addMAvv(M,sgn,if3,if4,if1,if2,if5,if6,2,1)
          call addMAvv(M,sgn,if3,if4,if1,if2,if5,if6,2,2)
          call addMAvv(M,sgn,if5,if6,if1,if2,if3,if4,1,1)
          call addMAvv(M,sgn,if5,if6,if1,if2,if3,if4,1,2)
          call addMAvv(M,sgn,if5,if6,if1,if2,if3,if4,2,1)
          call addMAvv(M,sgn,if5,if6,if1,if2,if3,if4,2,2)
          call addMAvv(M,sgn,if3,if4,if5,if6,if1,if2,1,1)
          call addMAvv(M,sgn,if3,if4,if5,if6,if1,if2,1,2)
          call addMAvv(M,sgn,if3,if4,if5,if6,if1,if2,2,1)
          call addMAvv(M,sgn,if3,if4,if5,if6,if1,if2,2,2)
          call addMAvv(M,sgn,if5,if6,if3,if4,if1,if2,1,1)
          call addMAvv(M,sgn,if5,if6,if3,if4,if1,if2,1,2)
          call addMAvv(M,sgn,if5,if6,if3,if4,if1,if2,2,1)
          call addMAvv(M,sgn,if5,if6,if3,if4,if1,if2,2,2)
	endif

	end
	
************************************************************************
        subroutine Mg_NCA(Mg,sgn,if1,if2,if3,if4,if5,if6)
************************************************************************
*	QCD background diagrams for e+e- --> 4 quarks + photon
*	Note: 1-photon exchange is converted into 1-gluon exchange 
*	      by adjusting the prefactor of the diagrams
*-----------------------------------------------------------------------
*       16.10.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 Mg(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	integer    sgn,if1,if2,if3,if4,if5,if6

        call addMAvv(Mg,sgn,if3,if4,if1,if2,if5,if6,1,1)
        call addMAvv(Mg,sgn,if3,if4,if1,if2,if5,if6,2,1)
        call addMAvv(Mg,sgn,if5,if6,if1,if2,if3,if4,1,1)
        call addMAvv(Mg,sgn,if5,if6,if1,if2,if3,if4,2,1)
        call addMAvv(Mg,sgn,if3,if4,if5,if6,if1,if2,1,1)
        call addMAvv(Mg,sgn,if3,if4,if5,if6,if1,if2,1,2)
        call addMAvv(Mg,sgn,if5,if6,if3,if4,if1,if2,1,1)
        call addMAvv(Mg,sgn,if5,if6,if3,if4,if1,if2,1,2)

	end
	
************************************************************************
        subroutine setprods(p,dir,n)
************************************************************************
*-----------------------------------------------------------------------
*       29.4.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 eiph(7),sp(7,7),csp(7,7)
	real*8 e(7),th(7),re(7),cth2(7),sth2(7),vp(7,7),p(7,0:3)
	integer n,i,j
        integer dir(7)

	common/prods/sp,csp,vp

        do 100 i=1,n
          e(i)    = p(i,0)
	  re(i)   = sqrt(e(i))
          k       = sqrt(p(i,1)**2+p(i,2)**2+p(i,3)**2)
          th(i)   = acos(p(i,3)/k)
	  cth2(i) = cos(th(i)/2d0) 
	  sth2(i) = sin(th(i)/2d0) 
          if (abs(sin(th(i))).lt.1d-10) then
            eiph(i) = 1d0
          else
            eiph(i) = dcmplx(p(i,1),p(i,2))/k/sin(th(i))
          endif
100     continue

	do 200 i=2,n
	do 200 j=1,i-1
	   sp(i,j) = 2d0*re(i)*re(j)
     &	             *(cth2(i)/eiph(i)*sth2(j)-sth2(i)*cth2(j)/eiph(j))
	  csp(i,j) = dconjg(sp(i,j))*dir(i)*dir(j)
	   vp(i,j) = sp(i,j)*csp(i,j)
	   sp(j,i) = - sp(i,j)
	  csp(j,i) = -csp(i,j)
	   vp(j,i) =   vp(i,j)
200	continue

	end

************************************************************************
        subroutine setM6null(M)
************************************************************************
*-----------------------------------------------------------------------
*       29.4.98 Stefan Dittmaier
************************************************************************
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	integer    i1,i2,i3,i4,i5,i6

	do 100 i1=-1,1,2
	do 100 i2=-1,1,2
	do 100 i3=-1,1,2
	do 100 i4=-1,1,2
	do 100 i5=-1,1,2
	do 100 i6=-1,1,2
	  M(i1,i2,i3,i4,i5,i6) = 0d0
100	continue
	
	end

************************************************************************
        subroutine setM7null(M)
************************************************************************
*-----------------------------------------------------------------------
*       28.5.98 Stefan Dittmaier
************************************************************************
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	integer    i1,i2,i3,i4,i5,i6,i7

	do 100 i1=-1,1,2
	do 100 i2=-1,1,2
	do 100 i3=-1,1,2
	do 100 i4=-1,1,2
	do 100 i5=-1,1,2
	do 100 i6=-1,1,2
	do 100 i7=-1,1,2
	  M(i1,i2,i3,i4,i5,i6,i7) = 0d0
100	continue
	
	end

************************************************************************
        subroutine addMvv(M,sgn,if1,if2,if3,if4,if5,if6,iv1,iv2)
************************************************************************
*                   \                 /
*                    \_             _/
*                 f1 |\             /| f3
*                      \    V1     /
*                       *vvvvvvvvv*--<--
*                       |            f4
*                      /|\
*                       |            f5 
*                       *vvvvvvvvv*-->--
*                      /    V2     \    
*                 f2 _/             \_
*                    /|             |\ f6
*                   /                 \
*-----------------------------------------------------------------------
*       29.4.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 A(-1:1,-1:1,-1:1),Appp
	complex*16 sp(7,7),csp(7,7)
	complex*16 fac,propv
	real*8     vp(7,7)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
	integer    sgn,iv1,iv2,if1,if2,if3,if4,if5,if6,f3,f4,f5,f6
	integer    n(6),i(6),i1,i3,i5
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	character*6 fname(6),dfname(6)

	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/prods/sp,csp,vp

	Appp(f3,f4,f5,f6) = sp(if1,f3)*csp(if2,f6)
     &		*( csp(if2,f4)*sp(if2,f5)+csp(f4,f6)*sp(f5,f6) )

	fac = -sgn*4d0/( vp(if2,if5)+vp(if2,if6)+vp(if5,if6) )
     &	          *PropV(vp(if3,if4),iv1)*PropV(vp(if5,if6),iv2) 

	A(+1,+1,+1) = Appp(if3,if4,if5,if6)
	A(+1,+1,-1) = Appp(if3,if4,if6,if5)
	A(+1,-1,+1) = Appp(if4,if3,if5,if6)
	A(+1,-1,-1) = Appp(if4,if3,if6,if5)

	n(if1) = 1
	n(if2) = 2
	n(if3) = 3
	n(if4) = 4
	n(if5) = 5
	n(if6) = 6

	do 100 i5=-1,1,2
	  i(5) = i5
	  i(6) = -i(5)
	do 100 i3=-1,1,2
	  i(3) = i3
	  i(4) = -i(3)
	  A(-1,i(3),i(5)) = dconjg(A(1,-i(3),-i(5)))
	do 100 i1=-1,1,2
	  i(1) = i1
	  i(2) = -i(1)
	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6)) = 
     &	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6)) 
     &	    + fac*A(i(1),i(3),i(5))
     &		 *Cvf(-i(1),iv1,if1)*Cvf(-i(1),iv2,if2)
     &		 *Cvf(-i(3),iv1,if3)*Cvf(-i(5),iv2,if5)
100	continue

	end

************************************************************************
        subroutine addMAvv(M,sgn,if1,if2,if3,if4,if5,if6,iv1,iv2)
************************************************************************
*                   \                 /
*                    \_             _/
*                 f1 |\             /| f3
*                      \    V1     /
*                       *vvvvvvvvv*--<--
*                       |            f4
*                      /|\                   +  photon !!!
*                       |            f5 
*                       *vvvvvvvvv*-->--
*                      /    V2     \    
*                 f2 _/             \_
*                    /|             |\ f6
*                   /                 \
*-----------------------------------------------------------------------
*       29.4.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 A(-1:1,-1:1,-1:1,-1:1),Apppm
	complex*16 sp(7,7),csp(7,7)
	complex*16 Pv(6,-1:1),Pkv(6,-1:1),propv
	real*8     Pf(6)
	real*8     vp(7,7)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
	integer    sgn,iv1,iv2,if1,if2,if3,if4,if5,if6
	integer    f1,f2,f3,f4,f5,f6
	integer    n(6),i(6),i1,i3,i5,ik
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/prods/sp,csp,vp

 	Apppm(q1,q2,q3,q4,q5,q6,f1,f2,f3,f4,f5,f6,ik) = sp(f1,f3)*(
     &	  Pv(f1,ik)*Pv(f2,ik)*( 
     &	     csp(f2,f6)/sp(f1,7)*(
     &	       (q3-q4)*Pf(f2)*sp(f1,f3)/sp(f3,7)
     &	         *(csp(f4,f2)*sp(f5,f2)+csp(f4,f6)*sp(f5,f6))
     &	      +(q6-q5)*Pf(f1)*sp(f1,f5)/sp(f5,7)
     &	         *(csp(f4,f1)*sp(f5,f1)+csp(f4,f3)*sp(f5,f3)) )
     &	    -q2*Pf(f1)/sp(f1,7)/sp(f2,7)
     &	      *(csp(f4,f1)*sp(f5,f1)+csp(f4,f3)*sp(f5,f3))
     &	      *(csp(f6,f2)*sp(f1,f2)+csp(f6, 7)*sp(f1, 7))
     &	    +(q1+q3-q4)*Pf(f1)*Pf(f2)*csp(f2,f6)*csp(f3,f4)*sp(f1,f3)
     &	      /sp(f1,7)*(csp(7,f2)*sp(f5,f2)+csp(7,f6)*sp(f5,f6)) )
     &	 -(q4-(q3-q4)*vp(f4,7)*Pv(f1,ik))*Pf(f2)
     &	    *Pv(f2,ik)*Pkv(f1,ik)*csp(f2,f6)/sp(f3,7)/sp(f4,7)
     &	    *( sp(f3,f4)*(csp(f4,f2)*sp(f5,f2)+csp(f4,f6)*sp(f5,f6))
     &	      +sp(f3, 7)*(csp( 7,f2)*sp(f5,f2)+csp( 7,f6)*sp(f5,f6)))
     &	 +(q6-(q5-q6)*vp(f6,7)*Pv(f2,ik))*Pf(f1)
     &	    *Pv(f1,ik)*Pkv(f2,ik)/sp(f5,7)/sp(f6,7)
     &	    *(csp(f2,f6)*sp(f5,f6)+csp(f2, 7)*sp(f5, 7))
     &	    *(csp(f4,f1)*sp(f5,f1)+csp(f4,f3)*sp(f5,f3))       )

	fac = sgn*4d0*sqrt(2d0)*el

	 Pv(if1,-1) = PropV(vp(if3,if4)                    ,iv1)
	Pkv(if1,-1) = PropV(vp(if3,if4)+vp(if3,7)+vp(if4,7),iv1)
	 Pv(if2,-1) = PropV(vp(if5,if6)                    ,iv2)
	Pkv(if2,-1) = PropV(vp(if5,if6)+vp(if5,7)+vp(if6,7),iv2)
	 Pv(if1,+1) = dconjg( Pv(if1,-1))
	Pkv(if1,+1) = dconjg(Pkv(if1,-1))
	 Pv(if2,+1) = dconjg( Pv(if2,-1))
	Pkv(if2,+1) = dconjg(Pkv(if2,-1))
	 Pf(if1)    = 1d0/( vp(if1,if3)+vp(if1,if4)+vp(if3,if4) )
	 Pf(if2)    = 1d0/( vp(if2,if5)+vp(if2,if6)+vp(if5,if6) )

	do 50 ik=-1,1,2

 	A(-ik,-ik,-ik,+ik) = 
     &	  Apppm(+q(if1),+q(if2),+q(if3),+q(if4),+q(if5),+q(if6),
     &		   if1,    if2,    if3,    if4,    if5,    if6 , ik)
 	A(-ik,-ik,+ik,+ik) = 
     &	  Apppm(+q(if1),+q(if2),+q(if3),+q(if4),-q(if6),-q(if5),
     &		   if1,    if2,    if3,    if4,    if6,    if5 , ik)
 	A(-ik,+ik,-ik,+ik) = 
     &	  Apppm(+q(if1),+q(if2),-q(if4),-q(if3),+q(if5),+q(if6),
     &		   if1,    if2,    if4,    if3,    if5,    if6 , ik)
 	A(-ik,+ik,+ik,+ik) = 
     &	  Apppm(+q(if1),+q(if2),-q(if4),-q(if3),-q(if6),-q(if5),
     &		   if1,    if2,    if4,    if3,    if6,    if5 , ik)
 	A(+ik,-ik,-ik,+ik) = 
     &	  Apppm(+q(if2),+q(if1),-q(if5),-q(if6),-q(if3),-q(if4),
     &		   if2,    if1,    if5,    if6,    if3,    if4 , ik)
 	A(+ik,-ik,+ik,+ik) = 
     &	  Apppm(+q(if2),+q(if1),+q(if6),+q(if5),-q(if3),-q(if4),
     &		   if2,    if1,    if6,    if5,    if3,    if4 , ik)
 	A(+ik,+ik,-ik,+ik) = 
     &	  Apppm(+q(if2),+q(if1),-q(if5),-q(if6),+q(if4),+q(if3),
     &		   if2,    if1,    if5,    if6,    if4,    if3 , ik)
 	A(+ik,+ik,+ik,+ik) = 
     &	  Apppm(+q(if2),+q(if1),+q(if6),+q(if5),+q(if4),+q(if3),
     &		   if2,    if1,    if6,    if5,    if4,    if3 , ik)

50	continue

	n(if1) = 1
	n(if2) = 2
	n(if3) = 3
	n(if4) = 4
	n(if5) = 5
	n(if6) = 6

	do 100 i5=-1,1,2
	  i(5) = i5
	  i(6) = -i(5)
	do 100 i3=-1,1,2
	  i(3) = i3
	  i(4) = -i(3)
	do 100 i1=-1,1,2
	  i(1) = i1
	  i(2) = -i(1)
	do 100 ik = -1,1,2
	  if (ik.eq.+1) then 
	    A(i(1),i(3),i(5),ik) = dconjg(A(i(1),i(3),i(5),ik))
	  endif
	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) = 
     &	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) 
     &	      + fac*A(i(1),i(3),i(5),ik)*Cvf(i(2),iv1,if1)
     &	  	*Cvf(i(2),iv2,if2)*Cvf(i(4),iv1,if3)*Cvf(i(6),iv2,if5)
100	continue

	end

************************************************************************
        subroutine addMG12vv(M,sgn,if1,if2,if3,if4,if5,if6,iv1,iv2)
************************************************************************
*                   \                 /
*                    \_             _/
*                 f1 |\             /| f3
*                      \    V1     /
*                       *vvvvvvvvv*--<--
*                       |            f4
*                      /|\                   +  gluon from f1,f2 !!!
*                       |            f5 
*                       *vvvvvvvvv*-->--
*                      /    V2     \    
*                 f2 _/             \_
*                    /|             |\ f6
*                   /                 \
*-----------------------------------------------------------------------
*	Note: f3,f4,f5,f6 = leptons !
*-----------------------------------------------------------------------
*       16.8.99 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 A(-1:1,-1:1,-1:1,-1:1),Apppm
	complex*16 sp(7,7),csp(7,7)
	complex*16 Pv(6,-1:1),propv
	real*8     Pf(6)
	real*8     vp(7,7)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
	integer    sgn,iv1,iv2,if1,if2,if3,if4,if5,if6
	integer    f1,f2,f3,f4,f5,f6
	integer    n(6),i(6),i1,i3,i5,ik
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/prods/sp,csp,vp

 	Apppm(f1,f2,f3,f4,f5,f6,ik) = 
     &	  sp(f1,f3)*Pv(f1,ik)*Pv(f2,ik)*( 
     &	    -Pf(f1)/sp(f1,7)/sp(f2,7)
     &	      *(csp(f4,f1)*sp(f5,f1)+csp(f4,f3)*sp(f5,f3))
     &	      *(csp(f6,f2)*sp(f1,f2)+csp(f6, 7)*sp(f1, 7))
     &	    +Pf(f1)*Pf(f2)*csp(f2,f6)*csp(f3,f4)*sp(f1,f3)
     &	      /sp(f1,7)*(csp(7,f2)*sp(f5,f2)+csp(7,f6)*sp(f5,f6)) )

	fac = sgn*4d0*sqrt(2d0)

	 Pv(if1,-1) = PropV(vp(if3,if4)                    ,iv1)
	 Pv(if2,-1) = PropV(vp(if5,if6)                    ,iv2)
	 Pv(if1,+1) = dconjg( Pv(if1,-1))
	 Pv(if2,+1) = dconjg( Pv(if2,-1))
	 Pf(if1)    = 1d0/( vp(if1,if3)+vp(if1,if4)+vp(if3,if4) )
	 Pf(if2)    = 1d0/( vp(if2,if5)+vp(if2,if6)+vp(if5,if6) )

	do 50 ik=-1,1,2
 	  A(-ik,-ik,-ik,+ik) = Apppm(if1,if2,if3,if4,if5,if6,ik)
 	  A(-ik,-ik,+ik,+ik) = Apppm(if1,if2,if3,if4,if6,if5,ik)
 	  A(-ik,+ik,-ik,+ik) = Apppm(if1,if2,if4,if3,if5,if6,ik)
 	  A(-ik,+ik,+ik,+ik) = Apppm(if1,if2,if4,if3,if6,if5,ik)
 	  A(+ik,-ik,-ik,+ik) = Apppm(if2,if1,if5,if6,if3,if4,ik)
 	  A(+ik,-ik,+ik,+ik) = Apppm(if2,if1,if6,if5,if3,if4,ik)
 	  A(+ik,+ik,-ik,+ik) = Apppm(if2,if1,if5,if6,if4,if3,ik)
 	  A(+ik,+ik,+ik,+ik) = Apppm(if2,if1,if6,if5,if4,if3,ik)
50	continue

	n(if1) = 1
	n(if2) = 2
	n(if3) = 3
	n(if4) = 4
	n(if5) = 5
	n(if6) = 6

	do 100 i5=-1,1,2
	  i(5) = i5
	  i(6) = -i(5)
	do 100 i3=-1,1,2
	  i(3) = i3
	  i(4) = -i(3)
	do 100 i1=-1,1,2
	  i(1) = i1
	  i(2) = -i(1)
	do 100 ik = -1,1,2
	  if (ik.eq.+1) then 
	    A(i(1),i(3),i(5),ik) = dconjg(A(i(1),i(3),i(5),ik))
	  endif
	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) = 
     &	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) 
     &	      + fac*A(i(1),i(3),i(5),ik)*Cvf(i(2),iv1,if1)
     &	  	*Cvf(i(2),iv2,if2)*Cvf(i(4),iv1,if3)*Cvf(i(6),iv2,if5)
100	continue

	end

************************************************************************
        subroutine addMG34vv(M,sgn,if1,if2,if3,if4,if5,if6,iv1,iv2)
************************************************************************
*                   \                 /
*                    \_             _/
*                 f1 |\             /| f3
*                      \    V1     /
*                       *vvvvvvvvv*--<--
*                       |            f4
*                      /|\                   +  gluon from f3,f4 !!!
*                       |            f5 
*                       *vvvvvvvvv*-->--
*                      /    V2     \    
*                 f2 _/             \_
*                    /|             |\ f6
*                   /                 \
*-----------------------------------------------------------------------
*	Note: f1,f2,f5,f6 = leptons !
*-----------------------------------------------------------------------
*       16.8.99 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 A(-1:1,-1:1,-1:1,-1:1),Apppm,Bpppm
	complex*16 sp(7,7),csp(7,7)
	complex*16 Pv(6,-1:1),Pkv(6,-1:1),propv
	real*8     Pf(6)
	real*8     vp(7,7)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
	integer    sgn,iv1,iv2,if1,if2,if3,if4,if5,if6
	integer    f1,f2,f3,f4,f5,f6
	integer    n(6),i(6),i1,i3,i5,ik
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/prods/sp,csp,vp

 	Apppm(f1,f2,f3,f4,f5,f6,ik) = sp(f1,f3)*(
     &	 -Pf(f2)*Pv(f2,ik)*Pkv(f1,ik)*csp(f2,f6)/sp(f3,7)/sp(f4,7)
     &	    *( sp(f3,f4)*(csp(f4,f2)*sp(f5,f2)+csp(f4,f6)*sp(f5,f6))
     &	      +sp(f3, 7)*(csp( 7,f2)*sp(f5,f2)+csp( 7,f6)*sp(f5,f6))) )

 	Bpppm(f1,f2,f3,f4,f5,f6,ik) = sp(f1,f3)*(
     &	 Pf(f1)*Pv(f1,ik)*Pkv(f2,ik)/sp(f5,7)/sp(f6,7)
     &	    *(csp(f2,f6)*sp(f5,f6)+csp(f2, 7)*sp(f5, 7))
     &	    *(csp(f4,f1)*sp(f5,f1)+csp(f4,f3)*sp(f5,f3))       )

	fac = sgn*4d0*sqrt(2d0)

	 Pv(if1,-1) = PropV(vp(if3,if4)                    ,iv1)
	Pkv(if1,-1) = PropV(vp(if3,if4)+vp(if3,7)+vp(if4,7),iv1)
	 Pv(if2,-1) = PropV(vp(if5,if6)                    ,iv2)
	Pkv(if2,-1) = PropV(vp(if5,if6)+vp(if5,7)+vp(if6,7),iv2)
	 Pv(if1,+1) = dconjg( Pv(if1,-1))
	Pkv(if1,+1) = dconjg(Pkv(if1,-1))
	 Pv(if2,+1) = dconjg( Pv(if2,-1))
	Pkv(if2,+1) = dconjg(Pkv(if2,-1))
	 Pf(if1)    = 1d0/( vp(if1,if3)+vp(if1,if4)+vp(if3,if4) )
	 Pf(if2)    = 1d0/( vp(if2,if5)+vp(if2,if6)+vp(if5,if6) )

	do 50 ik=-1,1,2
 	  A(-ik,-ik,-ik,+ik) =  Apppm(if1,if2,if3,if4,if5,if6,ik)
 	  A(-ik,-ik,+ik,+ik) =  Apppm(if1,if2,if3,if4,if6,if5,ik)
 	  A(-ik,+ik,-ik,+ik) = -Apppm(if1,if2,if4,if3,if5,if6,ik)
 	  A(-ik,+ik,+ik,+ik) = -Apppm(if1,if2,if4,if3,if6,if5,ik)
 	  A(+ik,-ik,-ik,+ik) = -Bpppm(if2,if1,if5,if6,if3,if4,ik)
 	  A(+ik,-ik,+ik,+ik) = -Bpppm(if2,if1,if6,if5,if3,if4,ik)
 	  A(+ik,+ik,-ik,+ik) =  Bpppm(if2,if1,if5,if6,if4,if3,ik)
 	  A(+ik,+ik,+ik,+ik) =  Bpppm(if2,if1,if6,if5,if4,if3,ik)
50	continue

	n(if1) = 1
	n(if2) = 2
	n(if3) = 3
	n(if4) = 4
	n(if5) = 5
	n(if6) = 6

	do 100 i5=-1,1,2
	  i(5) = i5
	  i(6) = -i(5)
	do 100 i3=-1,1,2
	  i(3) = i3
	  i(4) = -i(3)
	do 100 i1=-1,1,2
	  i(1) = i1
	  i(2) = -i(1)
	do 100 ik = -1,1,2
	  if (ik.eq.+1) then 
	    A(i(1),i(3),i(5),ik) = dconjg(A(i(1),i(3),i(5),ik))
	  endif
	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) = 
     &	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) 
     &	      + fac*A(i(1),i(3),i(5),ik)*Cvf(i(2),iv1,if1)
     &	  	*Cvf(i(2),iv2,if2)*Cvf(i(4),iv1,if3)*Cvf(i(6),iv2,if5)
100	continue

	end

************************************************************************
        subroutine addMG56vv(M,sgn,if1,if2,if3,if4,if5,if6,iv1,iv2)
************************************************************************
*                   \                 /
*                    \_             _/
*                 f1 |\             /| f3
*                      \    V1     /
*                       *vvvvvvvvv*--<--
*                       |            f4
*                      /|\                   +  gluon from f5,f6 !!!
*                       |            f5 
*                       *vvvvvvvvv*-->--
*                      /    V2     \    
*                 f2 _/             \_
*                    /|             |\ f6
*                   /                 \
*-----------------------------------------------------------------------
*	Note: f1,f2,f3,f4 = leptons !
*-----------------------------------------------------------------------
*       16.8.99 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 A(-1:1,-1:1,-1:1,-1:1),Apppm,Bpppm
	complex*16 sp(7,7),csp(7,7)
	complex*16 Pv(6,-1:1),Pkv(6,-1:1),propv
	real*8     Pf(6)
	real*8     vp(7,7)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
	integer    sgn,iv1,iv2,if1,if2,if3,if4,if5,if6
	integer    f1,f2,f3,f4,f5,f6
	integer    n(6),i(6),i1,i3,i5,ik
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/prods/sp,csp,vp

 	Apppm(f1,f2,f3,f4,f5,f6,ik) = sp(f1,f3)*(
     &	 Pf(f1)*Pv(f1,ik)*Pkv(f2,ik)/sp(f5,7)/sp(f6,7)
     &	    *(csp(f2,f6)*sp(f5,f6)+csp(f2, 7)*sp(f5, 7))
     &	    *(csp(f4,f1)*sp(f5,f1)+csp(f4,f3)*sp(f5,f3))       )

 	Bpppm(f1,f2,f3,f4,f5,f6,ik) = sp(f1,f3)*(
     &	 -Pf(f2)*Pv(f2,ik)*Pkv(f1,ik)*csp(f2,f6)/sp(f3,7)/sp(f4,7)
     &	    *( sp(f3,f4)*(csp(f4,f2)*sp(f5,f2)+csp(f4,f6)*sp(f5,f6))
     &	      +sp(f3, 7)*(csp( 7,f2)*sp(f5,f2)+csp( 7,f6)*sp(f5,f6))) )

	fac = sgn*4d0*sqrt(2d0)

	 Pv(if1,-1) = PropV(vp(if3,if4)                    ,iv1)
	Pkv(if1,-1) = PropV(vp(if3,if4)+vp(if3,7)+vp(if4,7),iv1)
	 Pv(if2,-1) = PropV(vp(if5,if6)                    ,iv2)
	Pkv(if2,-1) = PropV(vp(if5,if6)+vp(if5,7)+vp(if6,7),iv2)
	 Pv(if1,+1) = dconjg( Pv(if1,-1))
	Pkv(if1,+1) = dconjg(Pkv(if1,-1))
	 Pv(if2,+1) = dconjg( Pv(if2,-1))
	Pkv(if2,+1) = dconjg(Pkv(if2,-1))
	 Pf(if1)    = 1d0/( vp(if1,if3)+vp(if1,if4)+vp(if3,if4) )
	 Pf(if2)    = 1d0/( vp(if2,if5)+vp(if2,if6)+vp(if5,if6) )

	do 50 ik=-1,1,2
 	  A(-ik,-ik,-ik,+ik) =  Apppm(if1,if2,if3,if4,if5,if6,ik)
 	  A(-ik,-ik,+ik,+ik) = -Apppm(if1,if2,if3,if4,if6,if5,ik)
 	  A(-ik,+ik,-ik,+ik) =  Apppm(if1,if2,if4,if3,if5,if6,ik)
 	  A(-ik,+ik,+ik,+ik) = -Apppm(if1,if2,if4,if3,if6,if5,ik)
 	  A(+ik,-ik,-ik,+ik) = -Bpppm(if2,if1,if5,if6,if3,if4,ik)
 	  A(+ik,-ik,+ik,+ik) =  Bpppm(if2,if1,if6,if5,if3,if4,ik)
 	  A(+ik,+ik,-ik,+ik) = -Bpppm(if2,if1,if5,if6,if4,if3,ik)
 	  A(+ik,+ik,+ik,+ik) =  Bpppm(if2,if1,if6,if5,if4,if3,ik)
50	continue

	n(if1) = 1
	n(if2) = 2
	n(if3) = 3
	n(if4) = 4
	n(if5) = 5
	n(if6) = 6

	do 100 i5=-1,1,2
	  i(5) = i5
	  i(6) = -i(5)
	do 100 i3=-1,1,2
	  i(3) = i3
	  i(4) = -i(3)
	do 100 i1=-1,1,2
	  i(1) = i1
	  i(2) = -i(1)
	do 100 ik = -1,1,2
	  if (ik.eq.+1) then 
	    A(i(1),i(3),i(5),ik) = dconjg(A(i(1),i(3),i(5),ik))
	  endif
	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) = 
     &	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) 
     &	      + fac*A(i(1),i(3),i(5),ik)*Cvf(i(2),iv1,if1)
     &	  	*Cvf(i(2),iv2,if2)*Cvf(i(4),iv1,if3)*Cvf(i(6),iv2,if5)
100	continue

	end

************************************************************************
        subroutine addMvvv(M,sgn,if1,if2,if3,if4,if5,if6,iv)
************************************************************************
*                                     /
*                                   _/ f3
*                                   /|
*                                  / 
*                   \             *--<-- f4
*                    \_           <
*                 f1 |\           < W
*                      \     V    <
*                       *vvvvvvvvv*
*                      /          <
*                 f2 _/           < W
*                    /|           <
*                   /             *-->-- f5
*                                  \
*                                   \_
*                                   |\ f6
*                                     \
*-----------------------------------------------------------------------
*       13.5.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 A(-1:1),Ap
	complex*16 sp(7,7),csp(7,7)
	complex*16 fac,propv
	real*8     vp(7,7)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
	integer    sgn,iv,if1,if2,if3,if4,if5,if6,f1,f2
	integer    n(6),i(6),i1
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	character*6 fname(6),dfname(6)

	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/prods/sp,csp,vp

	Ap(f1,f2) =   csp(f2,if4)*csp( f2,if6)*sp(f1, f2)*sp(if3,if5)
     &		     +csp(f2,if4)*csp(if4,if6)*sp(f1,if5)*sp(if3,if4)
     &		     +csp(f2,if6)*csp(if4,if6)*sp(f1,if3)*sp(if5,if6)

	fac = -sgn*4d0*(q(if3)-q(if4))*cvw(iv)*PropV(vp(if1,if2),iv)
     &	          *PropV(vp(if3,if4),3)*PropV(vp(if5,if6),3) 

	A(+1) = Ap(if1,if2)
	A(-1) = Ap(if2,if1)

	n(if1) = 1
	n(if2) = 2
	n(if3) = 3
	n(if4) = 4
	n(if5) = 5
	n(if6) = 6

	  i(3) = +1
	  i(4) = -1
	  i(5) = +1
	  i(6) = -1
	do 100 i1 = -1,1,2
	  i(1) =  i1
	  i(2) = -i1
	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6)) = 
     &	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6)) 
     &	    + fac*A(i(1))*Cvf(-i(1),iv,if1)*Cvf(-1,3,if3)*Cvf(-1,3,if5)
100	continue

	end

************************************************************************
        subroutine addMAvvv(M,sgn,if1,if2,if3,if4,if5,if6,iv)
************************************************************************
*                                     /
*                                   _/ f3
*                                   /|
*                                  / 
*                   \             *--<-- f4
*                    \_           <
*                 f1 |\           < ^ W+
*                      \     V    <
*                       *vvvvvvvvv*		+ photon !!!
*                      /          <
*                 f2 _/           < ^ W+
*                    /|           <
*                   /             *-->-- f5
*                                  \
*                                   \_
*                                   |\ f6
*                                     \
*-----------------------------------------------------------------------
*       13.5.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 A(-1:1,-1:1),Apm,fac
	complex*16 sp(7,7),csp(7,7),propv
	complex*16 P12v(-1:1), P34w(-1:1), P56w(-1:1)
	complex*16 P12kv(-1:1),P34kw(-1:1),P56kw(-1:1)
	real*8     vp(7,7)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
	integer    sgn,iv,if1,if2,if3,if4,if5,if6,f1,f2,f3,f4,f5,f6
	integer    n(6),i(6),i1,ik
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/prods/sp,csp,vp

 	Apm(q1,q2,q3,q4,q5,q6,f1,f2,f3,f4,f5,f6,ik) =
     &	  (q3-q4)*P12v(ik)*P34w(ik)*P56w(ik)*sp(f3,f5)/sp(f3,7)
     &	    /sp(f5,7)*(  csp(f2,f4)*csp(f2,f6)*sp(f1,f2)*sp(f3,f5)
     &	    		+csp(f2,f4)*csp(f4,f6)*sp(f1,f5)*sp(f3,f4)
     &	    		+csp(f2,f6)*csp(f4,f6)*sp(f1,f3)*sp(f5,f6) )
     &	 +q2*P12kv(ik)*P34w(ik)*P56w(ik)/sp(f1,7)/sp(f2,7)*(
     &	    -csp(f4,f6)*( sp(f1,f5)*sp(f3,f4)
     &		    *(csp(f4,f2)*sp(f1,f2)+csp(f4,7)*sp(f1,7))
     &	         +sp(f1,f3)*sp(f5,f6)
     &		    *(csp(f6,f2)*sp(f1,f2)+csp(f6,7)*sp(f1,7)) )
     &	    +sp(f3,f5)*(csp(f4,f2)*sp(f1,f2)+csp(f4,7)*sp(f1,7))
     &		         *(csp(f6,f2)*sp(f1,f2)+csp(f6,7)*sp(f1,7)) )
     &	 +P12v(ik)*P34kw(ik)*P56w(ik)*(q4-(q3-q4)*vp(f4,7)*P34w(ik))
     &	    /sp(f3,7)/sp(f4,7)*(
     &	      csp(f2,f6)*(-sp(f1,f3)*sp(f5,f6)
     &		    *(csp(f6,f4)*sp(f3,f4)+csp(f6,7)*sp(f3,7))
     &	         +sp(f3,f5)*sp(f1,f2)
     &		    *(csp(f2,f4)*sp(f3,f4)+csp(f2,7)*sp(f3,7)) )
     &	     -sp(f1,f5)*(csp(f6,f4)*sp(f3,f4)+csp(f6,7)*sp(f3,7))
     &		*(csp(f2,f4)*sp(f3,f4)+csp(f2,7)*sp(f3,7)) )
     &	 +P12v(ik)*P34w(ik)*P56kw(ik)*(q6+(q6-q5)*vp(f6,7)*P56w(ik))
     &	    /sp(f5,7)/sp(f6,7)*(
     &	      csp(f2,f4)*( sp(f3,f5)*sp(f1,f2)
     &		    *(csp(f2,f6)*sp(f5,f6)+csp(f2,7)*sp(f5,7))
     &	         +sp(f1,f5)*sp(f3,f4)
     &		    *(csp(f4,f6)*sp(f5,f6)+csp(f4,7)*sp(f5,7)) )
     &	     +sp(f1,f3)*(csp(f2,f6)*sp(f5,f6)+csp(f2,7)*sp(f5,7))
     &	 	*(csp(f4,f6)*sp(f5,f6)+csp(f4,7)*sp(f5,7)) )

	fac = -sgn*4d0*sqrt(2d0)*el*(q(if3)-q(if4))*Cvw(iv)
     &		  *Cvf(-1,3,if3)*Cvf(-1,3,if5)

	P12v(-1)  = PropV(vp(if1,if2)                    ,iv)
	P12kv(-1) = PropV(vp(if1,if2)+vp(if1,7)+vp(if2,7),iv)
	P34w(-1)  = PropV(vp(if3,if4)                    , 3)
	P34kw(-1) = PropV(vp(if3,if4)+vp(if3,7)+vp(if4,7), 3)
	P56w(-1)  = PropV(vp(if5,if6)                    , 3)
	P56kw(-1) = PropV(vp(if5,if6)+vp(if5,7)+vp(if6,7), 3)
	P12v(+1)  = dconjg(P12v(-1))
	P12kv(+1) = dconjg(P12kv(-1))
	P34w(+1)  = dconjg(P34w(-1))
	P34kw(+1) = dconjg(P34kw(-1))
	P56w(+1)  = dconjg(P56w(-1))
	P56kw(+1) = dconjg(P56kw(-1))

	A(+1,-1) = 
     &	         Apm(+q(if1),+q(if2),+q(if3),+q(if4),+q(if5),+q(if6),
     &			if1,    if2,    if3,    if4,    if5,    if6,-1) 
	A(-1,-1) = 
     &	         Apm(-q(if2),-q(if1),+q(if3),+q(if4),+q(if5),+q(if6),
     &			if2,    if1,    if3,    if4,    if5,    if6,-1) 
	A(-1,+1) = 
     &	  dconjg(Apm(+q(if1),+q(if2),-q(if4),-q(if3),-q(if6),-q(if5),
     &			if1,    if2,    if4,    if3,    if6,    if5,+1))
	A(+1,+1) = 
     &	  dconjg(Apm(-q(if2),-q(if1),-q(if4),-q(if3),-q(if6),-q(if5),
     &			if2,    if1,    if4,    if3,    if6,    if5,+1))

	n(if1) = 1
	n(if2) = 2
	n(if3) = 3
	n(if4) = 4
	n(if5) = 5
	n(if6) = 6

	  i(3) = +1
	  i(4) = -1
	  i(5) = +1
	  i(6) = -1
	do 100 i1 = -1,1,2
	  i(1) =  i1
	  i(2) = -i1
	do 100 ik = -1,1,2
	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) = 
     &	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) 
     &	      + fac*A(i(1),ik)*Cvf(-i(1),iv,if1)
100	continue

	end

************************************************************************
        subroutine addMG56vvv(M,sgn,if1,if2,if3,if4,if5,if6,iv)
************************************************************************
*                                     /
*                                   _/ f3
*                                   /|
*                                  / 
*                   \             *--<-- f4
*                    \_           <
*                 f1 |\           < ^ W+
*                      \     V    <
*                       *vvvvvvvvv*		+ gluon from f5,f6 !!!
*                      /          <
*                 f2 _/           < ^ W+
*                    /|           <
*                   /             *-->-- f5
*                                  \
*                                   \_
*                                   |\ f6
*                                     \
*-----------------------------------------------------------------------
*	Note: f1,f2,f3,f4 = leptons !
*-----------------------------------------------------------------------
*       16.8.99 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 M(-1:1,-1:1,-1:1,-1:1,-1:1,-1:1,-1:1)
	complex*16 A(-1:1,-1:1),Apm,Bpm,fac
	complex*16 sp(7,7),csp(7,7),propv
	complex*16 P12v(-1:1), P34w(-1:1),P56kw(-1:1)
	real*8     vp(7,7)
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
	integer    sgn,iv,if1,if2,if3,if4,if5,if6,f1,f2,f3,f4,f5,f6
	integer    n(6),i(6),i1,ik
        integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	character*6 fname(6),dfname(6)

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
	common/prods/sp,csp,vp

 	Apm(f1,f2,f3,f4,f5,f6,ik) =
     &	  P12v(ik)*P34w(ik)*P56kw(ik)/sp(f5,7)/sp(f6,7)*(
     &	      csp(f2,f4)*( sp(f3,f5)*sp(f1,f2)
     &		    *(csp(f2,f6)*sp(f5,f6)+csp(f2,7)*sp(f5,7))
     &	         +sp(f1,f5)*sp(f3,f4)
     &		    *(csp(f4,f6)*sp(f5,f6)+csp(f4,7)*sp(f5,7)) )
     &	     +sp(f1,f3)*(csp(f2,f6)*sp(f5,f6)+csp(f2,7)*sp(f5,7))
     &	 	*(csp(f4,f6)*sp(f5,f6)+csp(f4,7)*sp(f5,7)) )

 	Bpm(f1,f2,f3,f4,f5,f6,ik) =
     &	  P12v(ik)*P34w(ik)*P56kw(ik)/sp(f5,7)/sp(f6,7)*(
     &	      csp(f2,f4)*( sp(f3,f5)*sp(f1,f2)
     &		    *(csp(f2,f6)*sp(f5,f6)+csp(f2,7)*sp(f5,7))
     &	         +sp(f1,f5)*sp(f3,f4)
     &		    *(csp(f4,f6)*sp(f5,f6)+csp(f4,7)*sp(f5,7)) )
     &	     +sp(f1,f3)*(csp(f2,f6)*sp(f5,f6)+csp(f2,7)*sp(f5,7))
     &	 	*(csp(f4,f6)*sp(f5,f6)+csp(f4,7)*sp(f5,7)) )

	fac = -sgn*4d0*sqrt(2d0)*(q(if3)-q(if4))*Cvw(iv)
     &		  *Cvf(-1,3,if3)*Cvf(-1,3,if5)

	P12v(-1)  = PropV(vp(if1,if2)                    ,iv)
	P34w(-1)  = PropV(vp(if3,if4)                    , 3)
	P56kw(-1) = PropV(vp(if5,if6)+vp(if5,7)+vp(if6,7), 3)
	P12v(+1)  = dconjg(P12v(-1))
	P34w(+1)  = dconjg(P34w(-1))
	P56kw(+1) = dconjg(P56kw(-1))

	A(+1,-1) =         Apm(if1,if2,if3,if4,if5,if6,-1) 
	A(-1,-1) =         Apm(if2,if1,if3,if4,if5,if6,-1) 
	A(-1,+1) = -dconjg(Bpm(if1,if2,if4,if3,if6,if5,+1))
	A(+1,+1) = -dconjg(Bpm(if2,if1,if4,if3,if6,if5,+1))

	n(if1) = 1
	n(if2) = 2
	n(if3) = 3
	n(if4) = 4
	n(if5) = 5
	n(if6) = 6

	  i(3) = +1
	  i(4) = -1
	  i(5) = +1
	  i(6) = -1
	do 100 i1 = -1,1,2
	  i(1) =  i1
	  i(2) = -i1
	do 100 ik = -1,1,2
	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) = 
     &	  M(i(n(1))*dir(1),i(n(2))*dir(2),i(n(3))*dir(3),
     &	    i(n(4))*dir(4),i(n(5))*dir(5),i(n(6))*dir(6),ik*dir(7)) 
     &	      + fac*A(i(1),ik)*Cvf(-i(1),iv,if1)
100	continue

	end

************************************************************************
        function PropV(p2,iv)
************************************************************************
*	Generic gauge-boson propagator
*-----------------------------------------------------------------------
*	general form:  1 / ( p2 - mv(p2) ),    
*	gauge bosons:  v = a,z,w,
*	  qprop = 0:  mv(p2) = mv(iv)^2,              
*	  qprop = 1:  mv(p2) = mv(iv)^2 - i*mv(iv)*gv(iv),              
*	  qprop = 2:  mv(p2) = mv(iv)^2 - i*mv(iv)*gv(iv)*theta(p2),     
*	  qprop = 3:  mv(p2) = mv(iv)^2 - i*p2/mv*gv(iv)*theta(p2),  
*-----------------------------------------------------------------------
*       25.8.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 PropV
	real*8 q(6),mv(3),mv2(3),gv(3)
	complex*16 cvf(-1:1,3,6),cvw(2)
        integer iv,qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
	character*6 fname(6),dfname(6)

	common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     &		q,qprop,quark,iso,gen,dir,pol,color,fname,dfname

	theta(x) = .5d0+sign(.5d0,x)

	if ((qprop.eq.0).or.(iv.eq.1)) then
          PropV = 1d0/( p2-mv2(iv) )
          return
	elseif ((qprop.eq.1).or.(qprop.eq.4)) then
          PropV = 1d0/( p2-mv2(iv)+dcmplx(0d0,mv(iv)*gv(iv)) )
          return
	elseif (qprop.eq.2) then
          PropV = 1d0/( p2-mv2(iv)+dcmplx(0d0,mv(iv)*gv(iv))*theta(p2) )
          return
	elseif (qprop.eq.3) then
          PropV = 1d0/( p2-mv2(iv)
     &		        +dcmplx(0d0,p2/mv(iv)*gv(iv))*theta(p2) )
          return
        endif

	write(*,*) 'Propagator flag not defined, qprop = ',qprop
	stop

	end

